unit IOTest;
{FREEWARE 100744,2565}
{Test fr Komponente IOPara}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  IOPara, ExtCtrls, StdCtrls, Buttons;

type
  TIOForm = class(TForm)
    IOPort1: TIOPort;
    GroupBox1: TGroupBox;
    Image1: TImage;
    InLumi1: TShape;
    InLumi2: TShape;
    InLumi3: TShape;
    InLumi4: TShape;
    InLumi5: TShape;
    InLumi6: TShape;
    InLumi7: TShape;
    InLumi8: TShape;
    OutLumi1: TShape;
    OutLumi2: TShape;
    OutLumi3: TShape;
    OutLumi4: TShape;
    OutLumi5: TShape;
    OutLumi6: TShape;
    OutLumi7: TShape;
    OutLumi8: TShape;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpeedButton7: TSpeedButton;
    SpeedButton8: TSpeedButton;
    SpeedButton9: TSpeedButton;
    ComboBox1: TComboBox;
    Label1: TLabel;
    InputEdit: TEdit;
    Label2: TLabel;
    OutputEdit: TEdit;
    Label3: TLabel;
    SpeedButton10: TSpeedButton;
    Timer1: TTimer;
    procedure IOPort1InputChanged(Sender: TObject);
    procedure IOPort1OutputChanged(Sender: TObject);
    procedure SpeedButton9Click(Sender: TObject);
    procedure SpeedButton1_8Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure OutputEditChange(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure SpeedButton10Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  IOForm: TIOForm;

implementation

{$R *.DFM}

var ShiftByte:Byte;

procedure TIOForm.IOPort1InputChanged(Sender: TObject);
begin
  with IOPort1 do
  begin
    if (DataIn and 1)>0 then
       InLumi1.Brush.Color:=clRed else InLumi1.Brush.Color:=clSilver;
    if (DataIn and 2)>0 then
       InLumi2.Brush.Color:=clRed else InLumi2.Brush.Color:=clSilver;
    if (DataIn and 4)>0 then
       InLumi3.Brush.Color:=clRed else InLumi3.Brush.Color:=clSilver;
    if (DataIn and 8)>0 then
       InLumi4.Brush.Color:=clRed else InLumi4.Brush.Color:=clSilver;
    if (DataIn and $10)>0 then
       InLumi5.Brush.Color:=clRed else InLumi5.Brush.Color:=clSilver;
    if (DataIn and $20)>0 then
       InLumi6.Brush.Color:=clRed else InLumi6.Brush.Color:=clSilver;
    if (DataIn and $40)>0 then
       InLumi7.Brush.Color:=clRed else InLumi7.Brush.Color:=clSilver;
    if (DataIn and $80)>0 then
       InLumi8.Brush.Color:=clRed else InLumi8.Brush.Color:=clSilver;
    InputEdit.Text:='$'+IntToHex(DataIn,2);
  end;
end;

procedure TIOForm.IOPort1OutputChanged(Sender: TObject);
begin
  with IOPort1 do
  begin
    if (DataOut and 1)>0 then
       OutLumi1.Brush.Color:=clBlue else OutLumi1.Brush.Color:=clSilver;
    if (DataOut and 2)>0 then
       OutLumi2.Brush.Color:=clBlue else OutLumi2.Brush.Color:=clSilver;
    if (DataOut and 4)>0 then
       OutLumi3.Brush.Color:=clBlue else OutLumi3.Brush.Color:=clSilver;
    if (DataOut and 8)>0 then
       OutLumi4.Brush.Color:=clBlue else OutLumi4.Brush.Color:=clSilver;
    if (DataOut and $10)>0 then
       OutLumi5.Brush.Color:=clBlue else OutLumi5.Brush.Color:=clSilver;
    if (DataOut and $20)>0 then
       OutLumi6.Brush.Color:=clBlue else OutLumi6.Brush.Color:=clSilver;
    if (DataOut and $40)>0 then
       OutLumi7.Brush.Color:=clBlue else OutLumi7.Brush.Color:=clSilver;
    if (DataOut and $80)>0 then
       OutLumi8.Brush.Color:=clBlue else OutLumi8.Brush.Color:=clSilver;
    OutputEdit.Text:='$'+IntToHex(DataOut,2);
  end;
end;

procedure TIOForm.SpeedButton9Click(Sender: TObject);
begin
  Timer1.Enabled:=False;
  IOPort1.DataOut:=$00;
  SpeedButton1.Down:=False;
  SpeedButton2.Down:=False;
  SpeedButton3.Down:=False;
  SpeedButton4.Down:=False;
  SpeedButton5.Down:=False;
  SpeedButton6.Down:=False;
  SpeedButton7.Down:=False;
  SpeedButton8.Down:=False;
  SpeedButton10.Down:=False;
end;

procedure TIOForm.SpeedButton1_8Click(Sender: TObject);
begin
  with IOPort1 do
  begin
    if Sender=SpeedButton1 then
    begin
      if (DataOut and 1)>0 then begin
                                  ResetBit(1);
                                  SpeedButton1.Down:=False;
                                end
                                else
                                begin
                                  SetBit(1);
                                  SpeedButton1.Down:=True;
                                end;
    end;
    if Sender=SpeedButton2 then
    begin
      if (DataOut and 2)>0 then begin
                                  ResetBit(2);
                                  SpeedButton2.Down:=False;
                                end
                                else
                                begin
                                  SetBit(2);
                                  SpeedButton2.Down:=True;
                                end;
    end;
    if Sender=SpeedButton3 then
    begin
      if (DataOut and 4)>0 then begin
                                  ResetBit(3);
                                  SpeedButton3.Down:=False;
                                end
                                else
                                begin
                                  SetBit(3);
                                  SpeedButton3.Down:=True;
                                end;
    end;
    if Sender=SpeedButton4 then
    begin
      if (DataOut and 8)>0 then begin
                                  ResetBit(4);
                                  SpeedButton4.Down:=False;
                                end
                                else
                                begin
                                  SetBit(4);
                                  SpeedButton4.Down:=True;
                                end;
    end;
    if Sender=SpeedButton5 then
    begin
      if (DataOut and $10)>0 then begin
                                  ResetBit(5);
                                  SpeedButton5.Down:=False;
                                end
                                else
                                begin
                                  SetBit(5);
                                  SpeedButton5.Down:=True;
                                end;
    end;
    if Sender=SpeedButton6 then
    begin
      if (DataOut and $20)>0 then begin
                                  ResetBit(6);
                                  SpeedButton6.Down:=False;
                                end
                                else
                                begin
                                  SetBit(6);
                                  SpeedButton6.Down:=True;
                                end;
    end;
    if Sender=SpeedButton7 then
    begin
      if (DataOut and $40)>0 then begin
                                  ResetBit(7);
                                  SpeedButton7.Down:=False;
                                end
                                else
                                begin
                                  SetBit(7);
                                  SpeedButton7.Down:=True;
                                end;
    end;
    if Sender=SpeedButton8 then
    begin
      if (DataOut and $80)>0 then begin
                                  ResetBit(8);
                                  SpeedButton8.Down:=False;
                                end
                                else
                                begin
                                  SetBit(8);
                                  SpeedButton8.Down:=True;
                                end;
    end;
  end;
end;

procedure TIOForm.FormCreate(Sender: TObject);
begin
  with IOPort1 do
  begin
    Port:=None;
    Enabled:=False;
    DataOut:=0;
    DataIn:=0;
    IOPort1InputChanged(Sender);
    IOPort1OutputChanged(Sender);
  end;
end;

procedure TIOForm.FormDestroy(Sender: TObject);
begin
  with IOPort1 do
  begin
    Port:=None;
    Enabled:=False;
  end;
end;

procedure TIOForm.OutputEditChange(Sender: TObject);
const Hex='0123456789ABCDEF';
var Value:Byte;
    test:Integer;
    s:String[3];
begin
{$R-}
  with IOPort1, OutputEdit do
  begin
    Trim(Text);
    if pos('$',Text)>0 then
    begin
      s:=Text;
      delete(s,pos('$',s),1);
      Value:=(pos(s[1],Hex)-1)*16 + (pos(s[2],Hex)-1);
    end
    else
    begin
      val(Text,Value,test);
      if test<>0 then Value:=0;
    end;
    Text:='$'+IntToHex(Value,2);
    DataOut:=Value;
  end;
end;

procedure TIOForm.ComboBox1Change(Sender: TObject);
begin
  with IOPort1, Combobox1 do
  begin
    IOPort1.Enabled:=False;
    case ItemIndex of
      0:Port:=None;
      1:Port:=LPT1;
      2:Port:=LPT2;
      3:Port:=LPT3;
    end;
    Application.ProcessMessages;
    ItemIndex:=0;
    if Port=LPT1 then ItemIndex:=1;
    if Port=LPT2 then ItemIndex:=2;
    if Port=LPT3 then ItemIndex:=3;
    if ItemIndex in [1..3] then IOPort1.Enabled:=True;
  end;
end;

procedure TIOForm.SpeedButton10Click(Sender: TObject);
begin
  with SpeedButton10 do
  begin
    Down:=True;
    Timer1.Enabled:=True;
    ShiftByte:=1;
  end;
end;

procedure TIOForm.Timer1Timer(Sender: TObject);
begin
  IOPort1.DataOut:=ShiftByte;
  ShiftByte:=ShiftByte shl 1;
  if ShiftByte=0 then ShiftByte:=1;
end;

end.
